

<!DOCTYPE html>

<html lang="en">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>7.3.67. thread_limit &#8212; Groonga v10.1.1-31-g1e46ba6 documentation</title>
    <link rel="stylesheet" href="../../_static/groonga.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    
    <script id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
    <script src="../../_static/jquery.js"></script>
    <script src="../../_static/underscore.js"></script>
    <script src="../../_static/doctools.js"></script>
    <script src="../../_static/language_data.js"></script>
    
    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="7.3.68. tokenize" href="tokenize.html" />
    <link rel="prev" title="7.3.66. table_tokenize" href="table_tokenize.html" /> 
  </head><body>
<div class="header">
  <h1 class="title">
    <a id="top-link" href="../../index.html">
      <span class="project">groonga</span>
      <span class="separator">-</span>
      <span class="description">An open-source fulltext search engine and column store.</span>
    </a>
  </h1>

  <div class="other-language-links">
    <ul>
      <li><a href="../../../../ja/html/reference/commands/thread_limit.html">日本語</a></li>
    </ul>
  </div>
</div>
  

    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="tokenize.html" title="7.3.68. tokenize"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="table_tokenize.html" title="7.3.66. table_tokenize"
             accesskey="P">previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>Reference manual</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../command.html" accesskey="U"><span class="section-number">7.3. </span>Command</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.3.67. </span><code class="docutils literal notranslate"><span class="pre">thread_limit</span></code></a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="thread-limit">
<h1><span class="section-number">7.3.67. </span><code class="docutils literal notranslate"><span class="pre">thread_limit</span></code><a class="headerlink" href="#thread-limit" title="Permalink to this headline">¶</a></h1>
<div class="section" id="summary">
<h2><span class="section-number">7.3.67.1. </span>Summary<a class="headerlink" href="#summary" title="Permalink to this headline">¶</a></h2>
<div class="versionadded">
<p><span class="versionmodified added">New in version 5.0.7.</span></p>
</div>
<p><code class="docutils literal notranslate"><span class="pre">thread_limit</span></code> has the following two features:</p>
<blockquote>
<div><ul class="simple">
<li><p>It returns the max number of threads.</p></li>
<li><p>It sets the max number of threads.</p></li>
</ul>
</div></blockquote>
<p><a class="reference internal" href="../executables/groonga.html"><span class="doc">groonga executable file</span></a> is the only Groonga server that
supports full <code class="docutils literal notranslate"><span class="pre">thread_limit</span></code> features.</p>
<p><a class="reference internal" href="../executables/groonga-httpd.html"><span class="doc">groonga-httpd</span></a> supports only one feature
that returns the max number of threads. The max number of threads of
<a class="reference internal" href="../executables/groonga-httpd.html"><span class="doc">groonga-httpd</span></a> always returns <code class="docutils literal notranslate"><span class="pre">1</span></code>
because <a class="reference internal" href="../executables/groonga-httpd.html"><span class="doc">groonga-httpd</span></a> uses single thread
model.</p>
<p>If you’re using Groonga as a library, <code class="docutils literal notranslate"><span class="pre">thread_limit</span></code> doesn’t work
without you set custom functions by
<a class="reference internal" href="../api/grn_thread.html#c.grn_thread_set_get_limit_func" title="grn_thread_set_get_limit_func"><code class="xref c c-func docutils literal notranslate"><span class="pre">grn_thread_set_get_limit_func()</span></code></a> and
<a class="reference internal" href="../api/grn_thread.html#c.grn_thread_set_set_limit_func" title="grn_thread_set_set_limit_func"><code class="xref c c-func docutils literal notranslate"><span class="pre">grn_thread_set_set_limit_func()</span></code></a>. If you set a function by
<a class="reference internal" href="../api/grn_thread.html#c.grn_thread_set_get_limit_func" title="grn_thread_set_get_limit_func"><code class="xref c c-func docutils literal notranslate"><span class="pre">grn_thread_set_get_limit_func()</span></code></a>, the feature that returns
the max number of threads works. If you set a function by
<a class="reference internal" href="../api/grn_thread.html#c.grn_thread_set_set_limit_func" title="grn_thread_set_set_limit_func"><code class="xref c c-func docutils literal notranslate"><span class="pre">grn_thread_set_set_limit_func()</span></code></a>, the feature that sets the
max number of threads works.</p>
</div>
<div class="section" id="syntax">
<h2><span class="section-number">7.3.67.2. </span>Syntax<a class="headerlink" href="#syntax" title="Permalink to this headline">¶</a></h2>
<p>This command takes only one optional parameter:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>thread_limit [max=null]
</pre></div>
</div>
</div>
<div class="section" id="usage">
<h2><span class="section-number">7.3.67.3. </span>Usage<a class="headerlink" href="#usage" title="Permalink to this headline">¶</a></h2>
<p>You can get the max number of threads by calling without any parameters:</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>thread_limit
# [[0, 1337566253.89858, 0.000355720520019531], 2]
</pre></div>
</div>
<p>If it returns <code class="docutils literal notranslate"><span class="pre">0</span></code>, your Groonga server doesn’t support the feature.</p>
<p>You can set the max number of threads by calling <code class="docutils literal notranslate"><span class="pre">max</span></code> parameter:</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>thread_limit --max 4
# [[0, 1337566253.89858, 0.000355720520019531], 2]
</pre></div>
</div>
<p>It returns the previous max number of threads when you pass
<code class="docutils literal notranslate"><span class="pre">max</span></code> parameter.</p>
</div>
<div class="section" id="parameters">
<h2><span class="section-number">7.3.67.4. </span>Parameters<a class="headerlink" href="#parameters" title="Permalink to this headline">¶</a></h2>
<p>This section describes all parameters.</p>
<div class="section" id="required-parameters">
<h3><span class="section-number">7.3.67.4.1. </span>Required parameters<a class="headerlink" href="#required-parameters" title="Permalink to this headline">¶</a></h3>
<p>There is no required parameter.</p>
</div>
<div class="section" id="optional-parameters">
<h3><span class="section-number">7.3.67.4.2. </span>Optional parameters<a class="headerlink" href="#optional-parameters" title="Permalink to this headline">¶</a></h3>
<p>There is one optional parameter.</p>
<div class="section" id="max">
<span id="thread-limit-max"></span><h4><span class="section-number">7.3.67.4.2.1. </span><code class="docutils literal notranslate"><span class="pre">max</span></code><a class="headerlink" href="#max" title="Permalink to this headline">¶</a></h4>
<p>Specifies the new max number of threads.</p>
<p>You must specify positive integer:</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>thread_limit --max 3
# [[0, 1337566253.89858, 0.000355720520019531], 4]
</pre></div>
</div>
<p>If you specify <code class="docutils literal notranslate"><span class="pre">max</span></code> parameter, <code class="docutils literal notranslate"><span class="pre">thread_limit</span></code> returns the
max number of threads before <code class="docutils literal notranslate"><span class="pre">max</span></code> is applied.</p>
</div>
</div>
</div>
<div class="section" id="return-value">
<h2><span class="section-number">7.3.67.5. </span>Return value<a class="headerlink" href="#return-value" title="Permalink to this headline">¶</a></h2>
<p>The command returns the max number of threads as body:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>[HEADER, N_MAX_THREADS]
</pre></div>
</div>
<p>If <code class="docutils literal notranslate"><span class="pre">max</span></code> is specified, <code class="docutils literal notranslate"><span class="pre">N_MAX_THREADS</span></code> is the max number of
threads before <code class="docutils literal notranslate"><span class="pre">max</span></code> is applied.</p>
<p>See <a class="reference internal" href="../command/output_format.html"><span class="doc">Output format</span></a> for <code class="docutils literal notranslate"><span class="pre">HEADER</span></code>.</p>
</div>
</div>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../../index.html">Table of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">7.3.67. <code class="docutils literal notranslate"><span class="pre">thread_limit</span></code></a><ul>
<li><a class="reference internal" href="#summary">7.3.67.1. Summary</a></li>
<li><a class="reference internal" href="#syntax">7.3.67.2. Syntax</a></li>
<li><a class="reference internal" href="#usage">7.3.67.3. Usage</a></li>
<li><a class="reference internal" href="#parameters">7.3.67.4. Parameters</a><ul>
<li><a class="reference internal" href="#required-parameters">7.3.67.4.1. Required parameters</a></li>
<li><a class="reference internal" href="#optional-parameters">7.3.67.4.2. Optional parameters</a><ul>
<li><a class="reference internal" href="#max">7.3.67.4.2.1. <code class="docutils literal notranslate"><span class="pre">max</span></code></a></li>
</ul>
</li>
</ul>
</li>
<li><a class="reference internal" href="#return-value">7.3.67.5. Return value</a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="table_tokenize.html"
                        title="previous chapter"><span class="section-number">7.3.66. </span><code class="docutils literal notranslate"><span class="pre">table_tokenize</span></code></a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="tokenize.html"
                        title="next chapter"><span class="section-number">7.3.68. </span><code class="docutils literal notranslate"><span class="pre">tokenize</span></code></a></p>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="tokenize.html" title="7.3.68. tokenize"
             >next</a> |</li>
        <li class="right" >
          <a href="table_tokenize.html" title="7.3.66. table_tokenize"
             >previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>Reference manual</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../command.html" ><span class="section-number">7.3. </span>Command</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.3.67. </span><code class="docutils literal notranslate"><span class="pre">thread_limit</span></code></a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2009-2021, Brazil, Inc.
    </div>
  </body>
</html>